/* This is a program which simply waits for an incoming
  connection request, instantiates an mNasD object, 
  And uses that object to serve the new connector. 

  Brian Sellden
*/

#include <iostream.h>
#include <stdlib.h> 
#include <errno.h> 
#include <string.h> 
#include <sys/types.h> 
#include <netinet/in.h> 
#include <sys/socket.h> 
#include <sys/wait.h> 
#include <arpa/inet.h>
#include "mNasD.h"

#define BACKLOG 0     /* how many pending connections queue will hold */

int main(int argc, char *argv[])
{
        int sock_fd, new_fd;  /* listen on sock_fd, new connection on new_fd */
        struct sockaddr_in my_addr;    /* my address information */
        struct sockaddr_in their_addr; /* connector's address information */
        unsigned int sin_size;
	mNasD nasd;
	int on; /* for setsockopt */
	char playBuf[128], *nasUrl=NULL,
	  defUrl[]="tcp/localhost:8000";

	if(argc == 1)
	  nasUrl = defUrl;
	else {
	  if((argc == 3) && (!strcmp(argv[1], "-a")))
			  nasUrl = argv[2];
	}

	if(nasUrl == NULL) {
	  cerr<<"\nUsage: nasd  [-a tcp/host:port]\n"<<endl;
	  exit(1);
	}

	cout<<"Looking for auvoxware server at "<<nasUrl<<endl;
	    /* Ok, get mNasD going... */
  nasd.initialize(nasUrl);
  if(nasd.ready()) {
    cout<<"Ready to go!"<<endl;

        if ((sock_fd = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
            perror("socket");
            exit(1);
        }

        my_addr.sin_family = AF_INET;         /* host byte order */
        my_addr.sin_port = htons(LISTEN_PORT);     /* short, network byte order */
        my_addr.sin_addr.s_addr = INADDR_ANY; /* auto-fill with my IP */
        bzero(&(my_addr.sin_zero), 8);        /* zero the rest of the struct */

	/* Set sock_fd to SOL_REUSEADDR, so we don't have to wait
	   for timeout before rebinding to the listening port */
  on=1;
  setsockopt(sock_fd,SOL_SOCKET,SO_REUSEADDR,
                                      (const char *) &on,sizeof(on));

        if (bind(sock_fd, (struct sockaddr *)&my_addr, sizeof(struct sockaddr))  == -1) {
            perror("bind");
            exit(1);
        }

        if (listen(sock_fd, BACKLOG) == -1) {
            perror("listen");
            exit(1);
        }

            sin_size = sizeof(struct sockaddr_in);
            if ((new_fd = accept(sock_fd, (struct sockaddr *)&their_addr,
                                                          &sin_size)) == -1) {
                perror("accept");
		return 1;
            }

            cout<<"mNasD: got connection from "
		<<inet_ntoa(their_addr.sin_addr)<<endl;;

    /* Introductory clip */
    //    sprintf(playBuf, "%d  ", 80);
    //    sprintf(playBuf+2, "%s", "/usr/local/mercator/UltraSonix.source/7.7/NasAudio/dirty12.wav");
    //    nasd.handleStartRequest(playBuf);

    nasd.serveClient(new_fd);
    close(sock_fd);
    close(new_fd);
  }
    else
      cerr<<"What the hell?"<<endl;

  return 0;
}
